function h = wls()
% WLS   Weighted least square filter design
%   H = WLS() returns the coefficients for a symmetric, causal Type 1
%   highpass filter, designed using weighted least squares.

% This file is part of Problem 1 in Homework 6.


% Disable a particular warning to avoid an annoying warning message
warning off optim:fmincon:SwitchingToMediumScale;

% Filter specifications

omega_s = 0.6;        % End of stopband frequency (multiples of pi)
omega_p = 0.75;       % Beginning of passband frequency (multiples of pi)
weights = [10 1];     % Error weighting in stopband/passband
des = [0 1];          % Desired frequency response in stopband/passband
L = 20;               % L = (M-1)/2 (half of the impulse response length)
K = 50;               % Number of points in the frequency grid


% For the frequency grid, we take K points between 0 and pi
omega = linspace(0, pi, K);

% Compute the matrices U and W and the vector d
U = ??? % To be completed
d = ??? % To be completed
W = ??? % To be completed


% Set up the optimization problem
A = ??? % To be completed
b = ??? % To be completed

[hh fval] = fmincon(@objfun, ones(L+1, 1), A, b);


% Use the solution of the optimization problem hh to compute the complete
% M-point impulse response.
h = ??? % To be completed

% Define objective function as nested function, so that it can access the
% parent function's variables
function f = objfun(hh)

    % Returns the squared error for the given filter coefficients h
% To be completed...

end

end
